# run.tcl 

set w .run
catch {destroy $w}
toplevel $w
wm title $w "Select input and output files for Onepop or Manypops"
wm iconname $w "run"
positionWindow $w

global input_fileName
global output_fileName
global current_path
global pap
global papm

set ls1 /
set ls2 .mst

set f [open $input_fileName r 0666]
  while {([gets $f line] >=0)} {
   if [regexp "masterfileprefix" $line] {
   set masterfile [GetValue "masterfileprefix = " $line]
   set masterfile $current_path$ls1$masterfile$ls2
#   puts stdout $input_fileName
#   puts stdout $masterfile
   break
  }
}
close $f

#return

frame $w.buttons
button $w.buttons.dismiss -text Dismiss -command "destroy $w"
pack  $w.buttons -side bottom -expand y -fill x -pady 4m
button $w.buttons.cancel -text "Clear" -command {
 set input_fileName ""
 set output_fileName ""
}
button $w.buttons.run -text "Run" -command {
 if { $number_pop == "one" } {
   exec $current_path/Onepop -i $input_fileName -o $output_fileName &
   }
 if { $number_pop == "many"} {
#   set masterfile $current_path$ls1$papm(app_masterfileprefix)$ls2
#   exec cp $current_path/masterfile . 
   exec $current_path/Manypops -i $input_fileName -o $output_fileName &
#  puts stdout masterfile
#   exec rm masterfile
   }
}
pack $w.buttons.dismiss $w.buttons.cancel $w.buttons.run -side left -expand 1 

frame $w.population
radiobutton $w.population.many -text "Many Populations" -variable number_pop \
		-value many
radiobutton $w.population.one -text "One Population   " -variable number_pop \
		-value one
pack $w.population.one $w.population.many -side left -fill x
set number_pop one

frame $w.file
label $w.file.label -text "Input file name:" -width 22 -anchor w
entry $w.file.entry -width 40 -textvariable input_fileName
pack $w.file.label $w.file.entry -side left
focus $w.file.entry

frame $w.string
label $w.string.label -text "Output file name:" -width 22 -anchor w
entry $w.string.entry -width 40 -textvariable output_fileName
pack $w.string.label $w.string.entry -side left

pack $w.population $w.file $w.string -padx 2m -pady 2m -side top

