/*----------------------------------------------------------------------------*/
/* appinputtemplate -- specs for sample input file  for  multi-population run */
/* (Manypops), which actually doesn't run ANY problem.  The IF lines DO NOT   */
/* APPEAR IN AN ACTUAL INPUT FILE.  In all cases in which a default value is  */
/* shown at run time, a blank line or blank in the value field can be used to */
/* indicate acceptance of the default shown.                                  */
/*----------------------------------------------------------------------------*/
npops = nn
startpopnum = nn  [0, npops-1]
finishpopnum = nn [startpopnum, npops-1]
ncycles = nnn
quiet = [0-3]
checkptfileprefix =   (blank or up to 6 characters, NOT starting with 'z')
restartfileprefix =   (blank or up to 6 characters, NOT starting with 'z')
masterfileprefix =    (blank or up to 8 characters, NOT starting with 'z')
ANY USER INPUT from infp IN app_read_problem_params GOES HERE.
IF (restartfileprefix IS BLANK) 
    permproblem = (y|n)
    all_subpops_use_same_parameters = (y|n)
IF (restartfileprefix NOT BLANK)
    no_more_changes = (y|n)
FOR (I=startpopnum; I<finishpopnum;I++) {
  IF (restartfileprefix IS BLANK || any_more_changes == y) 
    /* i.e., start of new run or first cycle extending a previous run */
    IF (restartfileprefix NOT BLANK && cycle == 0)
        changes_to_this_pop = (y|n)
    IF (changes_to_this_pop == y || (restartfileprefix IS BLANK
	    && (popno == startpopnum || NOT all_subpops_use_same_parameters))
      {
	/* Can specify or change any of the values below. */
       alpha_size = nn
       numfields = nn
       IF (not permproblem && alpha_size == 2)
	  superuniform    = (y|n)
       genspercycle    = nn
       popsize = nnn
       printstrings = (y|n)
       pcross = [0., 1.0]
       pmutation =  [0., 1.0] /* (NOTE: is probability/chromosome for
			       permproblem == y, and probability/field IF not
			       a permproblem) */
       IF (permproblem == n)
         pinversion = [0., 1.0]
       autocontrol_selection = (y|n)
       IF (autocontrol_selection == y)
         beta_s_tilde = [blank (automatic) or 0. - ~3]
       ELSE
         beta = [blank or 0. - ~3.]
       IF (autocontrol_selection == n && beta == blank)
         scaling_window = [-1 - 20] /* (NOTE: must be -1 IF using rank-based
				selection)    */
         IF (scaling_window < 0)
	   sigma_trunc = [0. - ~5.0]
	   scalemult = 0.0 or [1.0n - ~2.n] /* (NOTE: must be >1.0 IF
					     using rank-based selection.  */
       crowding_factor = [0 - ~5]   /* (NOTE:  0 means crowding off) */
       IF (crowding_factor > 0)
	   incest_reduction = [0 - ~5]
       conv_sigma_coeff = [0. - ~5.0]
       convinterval = [0 - ~100]
       IF (user reads in input during this operation from app_data, app_init)
	   USER-DEFINED INPUTS, IF ANY, (in app_data, app_init, etc.) HERE
       IF (tournament selection is compiled in)
	   tourneysize = n
       IF ((restartfileprefix IS BLANK) && (popno == startpopno)
           randomseed = .123
      }
}   
