
#ifndef SGAFUNC_DEFINED
#define SGAFUNC_DEFINED

typedef unsigned char *BIGNUM;

#ifndef TRUE
#define TRUE    1
#define FALSE   0
#endif

#define FAIL    0
#define SUCC    1
#define SKIP    2

/* Next line defines a max function, called maxx, named to avoid */
/* conflicting with max as defined on some systems, but NOT on others. */
/* Use of maxx in your appxxxxx.c routines is also recommended. */
#define maxx(n,m) (((n)>(m))? (n):(m))

/* app.c */
void objfunc();
void app_set_options();
void application();
void app_read_prob_params();
void app_data();
void app_init();
void app_user_init_pop();
void app_after_random_init();
void app_initreport();
void app_report();
void app_quiet_report();
void app_print_string();
void app_conv_rept();
void app_decide_if_converged();
void app_when_converged();
BOOL app_user_does_migration();
BOOL app_transform_migrant();
BOOL app_transform_chrom_to_std();
void app_generate();
void app_stats();
void app_before_inversion();
BOOL app_write_ckp_hdr();
BOOL app_read_ckp_hdr();
int  GetUtilitySize();
int  GetMaxUtilitySize();


/* bitmutat.c, swap.c, or scramble.c */
void mutation();
void field_mutation();

/* cx.c */
void crossover();
int  FirstNth();

/* ffscanf.c */
int ffscanf();
int ffscanf2();
int ffscanf4();
void SetBufferInValid();

/* generate.c */
void generation();
void crowder_with_optional_incest_reduction();
void usualgen();
int  closest();
void remap_then_objfunc();
void sys_util_survive_without_eval();

/* invercla.c or invercir.c */
void inversion();

/* initsubp.c */
void initialize_parallel();
void initialize();
void revisedata();
void initdata();
void init_random_pop();
void init_non_binary();
void init_superuniform_pop();
void initpermpop();
void initreport_parallel();
void initreport();
void writeinitpop();
void Initialize_For_New_Individual();
void initialize_inversion_map();

/* main*ga.c */
void subpopulation();
void SetUpMigration();
void RunWhichPops();
void DefineIO();
void GetUniversalInputs();
void EndOfCycle();
void ModifyRunBasedOnConvergence();
void GetThisRunInputs();

/* memory.c */
void initmalloc();
void freeall();
void nomemory();
void malloc_field_sizes_arrays();
void MallocPermOperSpace();
void sys_util_free();
void sys_util_malloc();
BOOL sys_util_malloc_utility_field();
void sys_util_malloc_bestever_utility();

/* random.c */
void advance_random();
int  flip();
void initrandomnormaldeviate();
double noise();
void Randomize();
double randomnormaldeviate();
float randomperc();
double double_randomperc();
int  rnd();
unsigned rnd_max_uint();
float rndreal();
void warmup_random();

/* report.c */
void report();
void writepop();
void writechrom();
void writefields();
void reptconv();
void calc_pct_conv();
void print_pct_conv();

/* select.c */
void select_memory();
void select_free();
void preselect();
int  select();

/* statisti.c */
void statistics();
void convergemeasure();
void sigma_truncation();
void linear_scale();
void Boltzmann_scale();
void window_scaling();
void globalstats();
void count_ones_at_loci();

/* utility.c */
void copyright();
void repchar();
void skip();
int  ithruj2int();
void int2ithruj();
int  getfield();
int  getfield_uneq_flds();
void putfield();
void putfield_uneq_flds();
long powerof2();
int  ceilinglogbase2();
int  floorlogbase2();
void chromtointarray();
void chromtointarray_uneq_flds();
void intarraytochrom();
int  hamming();
float indextofloat();
long floattoindex();
void CombineFileName();
BOOL Lock();
BOOL Unlock();
BOOL MakeLockable();
BOOL map_chromosome_to_std();
BOOL map_chromosome_to_std_uneq_flds();
void KillTime();
void sys_util_copy_utility();

/* Master.c & check*.c */
BOOL InitCPRead();
BOOL EndCPRead();
BOOL NthIndRead();
BOOL InitCPWrite();
BOOL EndCPWrite();
BOOL AddInd();
void SetBufferInValid();
BOOL GetMigrants();
BOOL GetFitnessBiasedMigrants();
BOOL ReadNeighborTable();
BOOL get_donor_pop_inversion_map_and_field_ends();
void ReadFromNeighbor();
BOOL FileRename();
int  ReadCheckPointHeader();
BOOL WriteCheckPointHeader();
void read_checkpointfile();
void write_checkpoint();
BOOL ReadCumStats();
BOOL UpdateCumStats();
BOOL InitializeCumStats();
void bestever_variable_malloc();
BOOL transform_inversion_pattern();
BOOL transform_inversion_pattern_uneq_flds();
void FreeUpMigrantHolder();
BOOL sys_util_write_utility();
BOOL sys_util_read_utility();
BOOL sys_util_read_best_utility();
BOOL sys_util_write_best_utility();

/* file_stat.c */
FILE *start_write();
FILE *start_read();
void get_bitflag();
int update_rstate();
int spin(int seed);

/* user_in.c */
void add_parameter();
char *get_parameter();
int parse_one_parameter();
int trim_string();
int delete_parameter();
void pop_inputs();
void get_pop_overrides();
void subpop_data();
int commandline();
void input_overrides();
void global_overrides();
void problem_inputs();
void usage();
void subpop_data(/*BOOL* */);
void input_overrides();
void global_overrides();

#endif
