/*----------------------------------------------------------------------------*/
/* swap.c -- Mutation via swapping of two randomly selected fields, from a    */
/*           permutation-type chromosome.                                     */
/*----------------------------------------------------------------------------*/

#include <stdlib.h>
#include "external.h"

char which_mutation[] = "swap.c";

void
mutation(child)
unsigned *child;

/* Perform a swap of two randomly selected fields of an individual,  with     */
/* probability pmutation, and count the number of mutations.  Note... in this */
/* case, pmutation is interpreted as probability PER INDIVIDUAL, NOT the      */
/* usual probability PER BIT.  This operator may be used ONLY for permutation */
/* problems (permproblem = 1).                                                */

{
    int     j, k, temp1, temp2, *dummy;


    if (!flip(pmutation))
	return;
    nmutation++;

    /* Dummy call to assure compatible crossover operator is loaded in */
    /* makefile. */
    if (FALSE) FirstNth(dummy, k, k, k); /* Never called */

    j = rnd(0, numfields - 1);
    k = rnd(0, numfields - 1);

    temp1 = getfield(j, numfields, child);
    temp2 = getfield(k, numfields, child);
    putfield(j, numfields, temp2, child);
    putfield(k, numfields, temp1, child);
}


void
field_mutation(child)
unsigned *child;
/* DUMMY FUNCTION for compatibility with non-perm.-type mutation operators. */
{
}
